package com.zipcodewilmington.bankaccountlab;
import java.util.Scanner;

public class ATM {
    Account savings = new SavingsAccount(15000);
    Account checking = new CheckingAccount(1250);
    Account business = new BusinessAccount(675849);
    Account[] personalAccounts;
    Account userSelection = null;
    boolean atTheMachine = true;

    public ATM (){

        personalAccounts = new Account[]{savings, checking, business};
    }

    public void print(String output, Object... args){
        System.out.printf(output, args);
    }

    public void println(String output, Object... args){
        print(output + "\n", args);
    }

    public Integer getIntegerInput(String prompt) {

        Integer userInput = 0;
        println(prompt);
        while(userInput == 0) {
            Scanner integerIn = new Scanner(System.in);
            if (integerIn.hasNextInt()) {
                userInput = integerIn.nextInt();
            } else {
                System.out.println("Must Be Greater Than 0! Please Try again!!");
            }
        }
        return userInput;
    }

    public void chooseAccount(){

        switch(getIntegerInput("What Account Would You Like To Access?\n (1)Savings, (2) Checking, (3) Business (4) To Exit")){
            case 1 :  userSelection = personalAccounts[0];
                    chooseAction();
            break;
            case 2 : userSelection = personalAccounts[1];
                    chooseAction();
            break;
            case 3 : userSelection = personalAccounts[2];
                    chooseAction();
            break;
            case 4 : atTheMachine = false;
            break;
            default: println("You Don't Have Access To That Account!");
            break;
        }
    }

    public void chooseAction() {

        switch(getIntegerInput("Would You Like To (1) Get Account Balance, (2) Make A Deposit, Or (3) Make A WithDrawl? ")){
            case 1 : println("Your Account Balance is: " + userSelection.getBalance());
                    userSelection = null;
            break;
            case 2 : int deposit = getIntegerInput("How Much Are You Depositing?");
                     userSelection.credit(deposit);
                     userSelection = null;
             break;
            case 3 : int withdrawl = getIntegerInput("How Much Are You WithDrawing?");
                    userSelection.debit(withdrawl);
                    userSelection = null;
        }
    }

    public static void main(String[] args){
        ATM moneyCenter = new ATM();

        moneyCenter.println("Welcome To The Money Center.");
        while(moneyCenter.atTheMachine != false){
        moneyCenter.chooseAccount();
        }

    }


}
